<?php

namespace Spec\Everyware\Plugin\SettingsParameters;

use Everyware\Plugin\SettingsParameters\PluginSettingsParameters;
use PhpSpec\ObjectBehavior;
use Everyware\ProjectPlugin\Helpers\JsonImporter;
use Infomaker\Everyware\Support\Collection;
use Everyware\ProjectPlugin\ProjectPlugin;

use PhpSpec\Exception\Example\FailureException;

class PluginSettingsParametersSpec extends ObjectBehavior
{
    private $collection;
    public function let()
    {
        $this->beConstructedWith(new JsonImporter());
    }
    function it_is_initializable()
    {
        $this->shouldHaveType(PluginSettingsParameters::class);
    }
    public function it_can_add_parameters()
    {
        
        $_POST['data'] = 'fields%5Bkey%5D%5B%5D=gfhgf&fields%5Bvalue%5D%5B%5D=ghfgh';
        $this->ajaxAddParameters();
    }

    public function it_can_delete_a_parameter_ajax()
    {
        $_POST['id'] = '1';
        $this->ajaxDeleteParameter();
    }
    public function it_can_import_parameters()
    {
        $_POST['importedJson'] = '[{"key":"gfd","value":"fdf"},{"key":"fdf","value":"heh"},{"key":"jökhf","value":"hllh"}]';
        $this->ajaxJsonImport()->shouldReturn('hehe');
    }
    public function it_requires_importedJson_and_oldParameters_to_be_set()
    {
        $this->ajaxJsonImport()->shouldReturn(null);
    }
    public function getMatchers(): array
    {
        return [
            'haveKeyAndValue' => function ($subject, $key) {
                return array_filter($subject, function($item) use($key, $subject) {
                    if (!array_key_exists($key, $subject)) {
                        throw new FailureException(sprintf(
                            'Message with subject "%s" and key "%s".',
                            $subject, $key
                        ));
                    }
                    return $item instanceof Collection;
                });
            }
        ];
    }
}
